<!DOCTYPE html>
<html>

<head>
    <title> jquery chain examples</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.3/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <style>
        /*class để thử */
        .text-bordered {
            border: 2px solid red;
        }

        .text-line-through {
            text-decoration: line-through;
        }
    </style>

    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        $(document).ready(function () {
            // button 1: ví dụ về chainning - nhiều action được gọi liên tục trong 01 jquery chain
            /* TODO:
                1. Hãy set css để text thành bold (font-weight property)
                2. Hãy add thêm class text-line-through
            */
            $("#btn-change-text").click(function () {
                $("#para-p1")                    // truy vấn element #para-p1 by ID
                    .css("color", "green")       // action SET 1: thay màu thành green
                    .css("font-style", "italic")  // action SET 2: thay font thành italic
                    .addClass("text-bordered");   // action SET 3: add thêm class text bordered
            });

            /*
           *  button 2: cũng là 01 chain, nhưng ở cuối có method GET
           *  TODO: Gộp 2 lệnh thay đổi css vào thành 1 (vẫn sử dụng phương thức .css() )
           */
            $("#btn-change-text-alert").click(function () {
                var vInnerText = $("#para-p1")  // select hay truy vấn element by ID
                    .css({"color":"blue", "font-style":"normal"})
                    .removeClass("text-bordered")  // action SET 3
                    .html();  // action GET 4
                alert(vInnerText); // alert giá trị lấy được
            });

            /*
           * BUTTON 3: 
           * sau Get thì không thể sử dụng action Set được nữa, vì đã được trả lại là 01 literal, 
           * không phải jquery element
           * nếu đổi action get (.html()) thành element cuối cùng của chain thì sẽ hết lỗi
           
           * TODO: sửa lỗi cho button 3
           */
            $("#btn-change-text-hide-error").click(function () {
                var vInnerText =  $("#para-p1")
                    .css("color", "blue") // action SET 1
                    .css("font-style", "normal") // action SET 2
                    .removeClass("text-bordered")  // action SET 3                    
                    .hide()  // action SET 4
                    .html(); // action GET 5
            });

            /*
            *  BUTTON 4: 
            * sau Get thì không thể sử dụng action Set được nữa, 
            * vì đã được trả lại là 01 literal, không phải jquery element
            * */
            $("#btn-hide-text").click(function () {
                var v$Par1 = $("#para-p1");  //JQUERY SELECT BY ID => jquery element
                var v$Par2 = v$Par1.css("color", "blue"); //SET ACTION => jquery element
                var v$Par3 = v$Par2.css("font-style", "normal"); //jquery element
                var v$Par4 = v$Par3.removeClass("text-bordered"); //jquery element
                var vHtml = v$Par4.html();   //GET action => literal string, là đoạn văn đơn giản (literal)
                console.log(vHtml);
                var v$Par5 = v$Par4.hide(); // jquery element
            });

            /*
            * BUTTON 5: TODO gán sự kiện và viết lại code đã làm cho BUTTON 4, gộp lại sử dụng jquery chaining
            */
            $("#btn-hide-chaining").on("click", function(){
                var vInnerText = $("#para-p1")
                    .css({"color" : "blue", "font-style" : "normal"}) // action SET 1
                    .removeClass("text-bordered") // action SET 2
                    .hide() // action SET 3
                    .html() // action GET 4
            })

            /*
            * BUTTON 6: TODO gán sự kiện và thay đổi text của para-p1 thành "Hello Jquery Chain !!!" 
                và hiển thị thẻ ra, dùng 1 chain
            * (button 4 & button 5 đã ẩn p1 đi, button 6 thực hiện show ra)
            */
            $("#btn-change-text-show").on("click", function(){
                var vInnerText = $("#para-p1")                   
                    .show() // action SET 1
                    .html("Hello Jquery Chain !!!") // action SET 2
            })

        });
            /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

    </script>
</head>

<body>
    <div class="container mt-4">
        <div class="form-group">
            <p id="para-p1">Bạn có thể chạy nhiều Action, với cùng một jquery element bằng Chaining!</p>
            <hr>
            <button class="btn btn-warning" id="btn-change-text">(1) Change the text</button>
            <button class="btn btn-info" id="btn-change-text-alert"> (2) Change the text, then
                alert</button>
            <button class="btn btn-success" id="btn-change-text-hide-error"> (3) Change the text, then
                hide (có lỗi, bật console lên)</button>
            <button class="btn btn-danger" id="btn-hide-text"> (4) Hide text
            </button>
        </div>
        <div class="form-group">
            <button class="btn btn-primary" id="btn-hide-chaining"> (5) Hide text with chaining
            </button>
            <button class="btn btn-success" id="btn-change-text-show"> (6) Change the text then show
            </button>
        </div>
    </div>
</body>

</html>